package speiger.src.coreengine.rendering.gui.font;

import java.util.Map;

import speiger.src.coreengine.assets.AssetLocation;
import speiger.src.coreengine.rendering.gui.font.glyth.Glyth;
import speiger.src.coreengine.rendering.gui.font.glyth.GlythData;
import speiger.src.coreengine.rendering.gui.font.glyth.UnbakedGlyth.GlythBaker;

public class Font {
	Map<AssetLocation, FontGroup> fonts;
	GlythBaker baker;
	float size;
	float oversample;
	GlythCache[] styledCache = new GlythCache[] {new GlythCache(this, 0), new GlythCache(this, 1), new GlythCache(this, 2), new GlythCache(this, 3)};
	
	protected Font(Map<AssetLocation, FontGroup> fonts, GlythBaker baker, float size, float oversample) {
		this.fonts = fonts;
		this.baker = baker;
		this.size = size;
		this.oversample = oversample;
	}
	
	public GlythData data(AssetLocation font, int codepoint, int style) {
		return styledCache[style & 0x3].data(font, codepoint);
	}
	
	public Glyth glyth(AssetLocation font, int codepoint, int style) {
		return styledCache[style & 0x3].glyth(font, codepoint);
	}
	
	protected FontGroup font(AssetLocation font) {
		return fonts.get(font);
	}
}
